#include "behaviour.h"

void parse_key_stack(GameControl** gamec) {

	gint direction,can;
	Monster* bump = NULL;
	Item* weapon;
	
	if((*gamec)->turn->cost_cnt == 0) {
	
		if(g_list_length((*gamec)->key_stack) > 0) {

			switch((gint)g_list_first((*gamec)->key_stack)->data) {

				case GDK_KP_Up:
					direction = UP;
					break;
				case GDK_KP_Page_Up:
					direction = UP_RIGHT;
					break;
				case GDK_KP_Right:
					direction = RIGHT;
					break;
				case GDK_KP_Page_Down:
					direction = DOWN_RIGHT;
					break;
				case GDK_KP_Down:
					direction = DOWN;
					break;
				case GDK_KP_End:
					direction = DOWN_LEFT;
					break;
				case GDK_KP_Left:
					direction = LEFT;
					break;
				case GDK_KP_Home:
					direction = UP_LEFT;
					break;
				default:
					break;		
	
			}

			if((can = can_move_thing((gamec),(*gamec)->turn,direction,&bump)) == YES_CLEAR) {

				move_thing((gamec),(*gamec)->turn,direction);
				(*gamec)->turn->cost_cnt = (*gamec)->turn->move_cost;
				change_monster_state_step((*gamec)->turn);

			} else if(can == NO_MONSTER || can == NO_ITEM) {

				weapon = attack_right(gamec,(*gamec)->turn,direction);
				(*gamec)->turn->cost_cnt = weapon->use_cost;

			}

			change_monster_state_facing((*gamec)->turn,((*gamec)->turn->state_flags & 7),direction);
			(*gamec)->key_stack = g_list_remove((*gamec)->key_stack,g_list_first((*gamec)->key_stack)->data);

		}

	} else {

		((*gamec)->turn->cost_cnt)--;

	}
}

void behave_do_nothing(GameControl** gamec,Monster* monster) {

}

void behave_guard_up_down(GameControl** gamec,Monster* monster) {

	Monster* bump = NULL;
	gint can,n;

	if(!(((gint)lookup_memory(monster->memory,0) == UP) || 
	     ((gint)lookup_memory(monster->memory,0) == DOWN) )) {

		monster->memory = set_memory(monster->memory,0,INT_MEM,DOWN,NULL);

	}

	if(monster->cost_cnt == 0) {

		if((gint)lookup_memory(monster->memory,1) == 10) {

			monster->memory = set_memory(monster->memory,1,INT_MEM,0,NULL);

			if((gint)lookup_memory(monster->memory,0) == DOWN) {
				
				monster->memory = set_memory(monster->memory,0,INT_MEM,UP,NULL);
				change_monster_state_facing(monster,(monster->state_flags & 7),UP);

			} else {
		
				monster->memory = set_memory(monster->memory,0,INT_MEM,DOWN,NULL);
				change_monster_state_facing(monster,(monster->state_flags & 7),DOWN);

			}

		}

		if((gint)lookup_memory(monster->memory,0) == UP) {

			if((can = can_move_thing((gamec),monster,UP,&bump)) == YES_CLEAR) {

				move_thing((gamec),monster,UP);
				monster->cost_cnt = monster->move_cost;
			} else {


				monster->memory = set_memory(monster->memory,0,INT_MEM,DOWN,NULL);
				monster->memory = set_memory(monster->memory,1,INT_MEM,0,NULL);
				change_monster_state_facing(monster,(monster->state_flags & 7),DOWN);

			}

		} else {

			if((can = can_move_thing((gamec),monster,DOWN,&bump)) == YES_CLEAR) {

				move_thing((gamec),monster,DOWN);
				monster->cost_cnt = monster->move_cost;

			} else {

				monster->memory = set_memory(monster->memory,0,INT_MEM,UP,NULL);
				monster->memory = set_memory(monster->memory,1,INT_MEM,0,NULL);
				change_monster_state_facing(monster,(monster->state_flags & 7),UP);
	
			}

		}

		change_monster_state_step(monster);
		n = (gint)lookup_memory(monster->memory,1) + 1;
		monster->memory = set_memory(monster->memory,1,INT_MEM,n,NULL);

	} else {
	
		(monster->cost_cnt)--;

	}

}

gboolean try_to_hit(GameControl** gamec,Monster* tori,Monster* uke,gint weapon_sort) {

	gint rn = rand(),skill = lookup_skill(tori->weapon_skills,weapon_sort);
	gboolean res;

	res = ((((100 - uke->armor) * skill) / 100) >= ((rn%100)+1));

	return res;

}

void cause_damage(GameControl** gamec,Monster* uke,gint dmg) {

	uke->cur_hp -= dmg;

	if(uke->cur_hp <= 0) {

		kill_monster(gamec,uke);

	}

}

void kill_monster(GameControl** gamec,Monster* uke) {

	gint i,j;

	g_print("%s has died\n",uke->name->str);

	if(uke->type == MONSTER) {

		/* later turn into corpse item, now I just take it off the map. */
		for(j=0;j<uke->height;j++)
		for(i=0;i<uke->width;i++)
			add_update(gamec,uke->x+i,uke->y+j);

		(*gamec)->monsters = g_list_remove((*gamec)->monsters,uke);
		remove_from_map(gamec,uke);

	} else if(uke->type == ITEM) {

		/* later turn into broken item, now I just take it off the map. */
		for(j=0;j<uke->height;j++)
		for(i=0;i<uke->width;i++)
			add_update(gamec,uke->x+i,uke->y+j);

		remove_from_map(gamec,uke);

	}

	/* the correct way to destroy an item:

		item = MAP(2+i,2+j)->ios;
		remove_from_map(gamec,(Monster*)item);
		(*gamec)->items = g_list_remove((*gamec)->items,item);
		zap_item(item);
	*/

}

Item* attack_right(GameControl** gamec,Monster* tori,gint direction) {

	gint dmg,can,rn = rand();
	Monster* uke = NULL;
	Item* weapon;

	weapon = lookup_contains(tori->contains,RIGHT_HAND);
	if(weapon != NULL && weapon->dmg_sort == WIELD) {

		can = can_move_thing(gamec,tori,direction,&uke);

		if(can == NO_ITEM || can == NO_MONSTER) {

			if(try_to_hit(gamec,tori,uke,weapon->sort) == TRUE) {

				dmg = (rn%((weapon->max_dmg)-(weapon->min_dmg)))+weapon->min_dmg;
				g_print("you hit with %s and cause %d damage\n",weapon->name->str,dmg);
				cause_damage(gamec,uke,dmg);

			} else {

				g_print("you miss\n");

			}

		}

		return weapon;

	} else {

		can = can_move_thing(gamec,tori,direction,&uke);
		if(can == NO_ITEM || can == NO_MONSTER) {

			if(try_to_hit(gamec,tori,uke,UNARMED) == TRUE) {

				dmg = (rn%((tori->max_dmg)-(tori->min_dmg)))+tori->min_dmg;
				g_print("you hit with %s and cause %d damage\n","your fist",dmg);
				cause_damage(gamec,uke,dmg);

			} else {

				g_print("you miss\n");

			}

		}

		return (Item*)tori;

	}

}

gint can_move_x_y(GameControl** gamec,gint x,gint y,gint access,Monster** bump_res) {

	/* map restrictions */
	
	if(x>=(MAX_MAP_X-1) || y>=(MAX_MAP_Y-1))
		return NO_ACCESS;

	if(x<0 || y<0)
		return NO_ACCESS;

	/* things in the way */

	if(MAP(x,y)->ios != NULL)
		(*bump_res) = (Monster*)(MAP(x,y)->ios);

	if(MAP(x,y)->mos != NULL)
		(*bump_res) = MAP(x,y)->mos;

	if((access & MAP(x,y)->kind) == 0)
		 return NO_ACCESS;

	if((MAP(x,y)->mos) != NULL)
		return NO_MONSTER;

	/* all clear */

	if((MAP(x,y)->ios) != NULL)
		if((MAP(x,y)->ios->properties & IS_TREADABLE) == 0)
			return NO_ITEM;

	return YES_CLEAR;

}

gint can_move_thing(GameControl** gamec,Monster* monster,gint direction,Monster** bump_res) {

	gint i,res;

	switch(direction) {

		case UP: 
			for(i=0;i<monster->width;i++)
				if((res = can_move_x_y((gamec),(monster->x)+i,(monster->y)-1,
				                       monster->access,bump_res)) != YES_CLEAR) {
					return res;
				}
			break;
		case UP_RIGHT: 
			for(i=0;i<monster->width;i++)
				if((res = can_move_x_y((gamec),(monster->x)+i+1,(monster->y)-1,
                                                       monster->access,bump_res)) != YES_CLEAR) {
					return res;
				}
			for(i=1;i<monster->height;i++)
				if((res = can_move_x_y((gamec),(monster->x)+(monster->width),(monster->y)+i-1,
				                       monster->access,bump_res)) != YES_CLEAR) {
					return res;
				}
			break;
		case RIGHT: 
			for(i=0;i<monster->height;i++)
				if((res = can_move_x_y((gamec),(monster->x)+(monster->width),(monster->y)+i,
				                       monster->access,bump_res)) != YES_CLEAR) {
					return res;
				}
			break;
		case DOWN_RIGHT: 
			for(i=0;i<monster->width;i++)
				if((res = can_move_x_y((gamec),(monster->x)+i+1,(monster->y)+(monster->height),
				                       monster->access,bump_res)) != YES_CLEAR) {
					return res;
				}
			for(i=1;i<monster->width;i++)
				if((res = can_move_x_y((gamec),(monster->x)+(monster->width),(monster->y)+(monster->height)-i,
				                       monster->access,bump_res)) != YES_CLEAR) {
					return res;
				}
			break;
		case DOWN: 
			for(i=0;i<monster->width;i++) {
				if((res = can_move_x_y((gamec),(monster->x)+i,(monster->y)+(monster->height),
				                       monster->access,bump_res)) != YES_CLEAR) {
					return res;
				}
			}
			break;
		case DOWN_LEFT: 
			for(i=0;i<monster->width;i++)
				if((res = can_move_x_y((gamec),(monster->x)-1+i,(monster->y)+(monster->height),
                                                       monster->access,bump_res)) != YES_CLEAR) {
					return res;
				}
			for(i=1;i<monster->width;i++)
				if((res = can_move_x_y((gamec),(monster->x)-1,(monster->y)+i,
 	                                              monster->access,bump_res)) != YES_CLEAR) {
					return res;
				}
			break;
		case LEFT: 
			for(i=0;i<monster->height;i++)
				if((res = can_move_x_y((gamec),(monster->x)-1,(monster->y)+i,
                                                       monster->access,bump_res)) != YES_CLEAR) {
					return res;
				}
			break;
		case UP_LEFT: 
			for(i=0;i<monster->width;i++)
				if((res = can_move_x_y((gamec),(monster->x)-1+i,(monster->y)-1,
				                       monster->access,bump_res)) != YES_CLEAR) {
					return res;
				}
			for(i=1;i<monster->width;i++)
				if((res = can_move_x_y((gamec),(monster->x)-1,(monster->y)+i-1,
				                       monster->access,bump_res)) != YES_CLEAR) {
					return res;
				}
			break;
		default: 
			break;

	}

	return res;

}

void move_thing(GameControl** gamec,Monster* monster,gint direction) {

	gint oldx,oldy,x,y,i,j;

	oldx = monster->x;
	oldy = monster->y;
	
	remove_from_map((gamec),monster);

	switch(direction) {
	
		case UP: 
			x = monster->x;
			y = monster->y-1;
			break;
		case UP_RIGHT:
			x = monster->x+1;
			y = monster->y-1;
			break;
		case RIGHT:
			x = monster->x+1;
			y = monster->y;
			break;
		case DOWN_RIGHT:
			x = monster->x+1;
			y = monster->y+1;
			break;
		case DOWN:
			x = monster->x;
			y = monster->y+1;
			break;
		case DOWN_LEFT:
			x = monster->x-1;
			y = monster->y+1;
			break;
		case LEFT:
			x = monster->x-1;
			y = monster->y;
			break;
		case UP_LEFT:
			x = monster->x-1;
			y = monster->y-1;
			break;
		default:
			x = monster->x;
			y = monster->y;
			break;
	}

	add_to_map((gamec),monster,x,y);

	add_update((gamec),(monster->x),(monster->y));

	for(j=0;j<monster->height;j++)
	for(i=0;i<monster->width;i++) {

		add_update((gamec),(oldx)+i,(oldy)+j);

	}

}
