#include "sprite.h"

Sprite* new_sprite() {

	Sprite* new = (Sprite*) g_malloc(sizeof(Sprite));

	new->image = NULL;
	new->pixmap = NULL;
	new->mask = NULL;

	return new;

}

void zap_sprite(Sprite* sprite) {

	if(sprite != NULL) {

		if(sprite->image != NULL) {

			g_free(sprite->image); /* FIXME: change into something unref-like */
			sprite->image = NULL;

		}

		if(sprite->pixmap != NULL) {

			g_free(sprite->pixmap); /* FIXME: change into something unref-like */
			sprite->pixmap = NULL;
		
		}

		if(sprite->mask != NULL) {

			g_free(sprite->mask); /* FIXME: change into something unref-like */
			sprite->mask = NULL;
		
		}

		g_free(sprite);
		sprite = NULL;

	}

}

SpriteNr* new_sprite_nr() {

	SpriteNr* new = (SpriteNr*) g_malloc(sizeof(SpriteNr));

	new->key = 0;
	new->nr = 0;

	return new;

}

void zap_sprite_nr(SpriteNr* sprite_nr) {

	if(sprite_nr != NULL) {

		g_free(sprite_nr);
		sprite_nr = NULL;

	}

}

void init_image_files(GameControl** gamec) {
	
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/intro_screen.jpg");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/logo.jpg");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/unknown_space.xpm");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/grass_1.xpm");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/grass_2.xpm");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/dirt_1.xpm");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/dirt_2.xpm");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/unknown_item.xpm");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/campfire_doused.xpm");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/campfire_1.xpm");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/campfire_2.xpm");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/campfire_3.xpm");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/campfire_4.xpm");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/rug_1.xpm");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/rug_2.xpm");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/boulder_1.xpm");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/boulder_2.xpm");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/tree_1.xpm");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/tree_2.xpm");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/big_tree.xpm");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/tree_broken.xpm");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/barrel_1.xpm");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/barrel_2.xpm");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/barrel_broken.xpm");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/mushroom_ring.xpm");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/short_sword.xpm");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/spiked_club.xpm");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/ogre_down_walk_left.xpm");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/ogre_down_walk_right.xpm");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/ogre_up_walk_left.xpm");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/ogre_up_walk_right.xpm");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/ogre_left_walk_left.xpm");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/ogre_left_walk_right.xpm");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/ogre_right_walk_left.xpm");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/ogre_right_walk_right.xpm");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/knight_down_walk_left.xpm");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/knight_down_walk_right.xpm");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/knight_up_walk_left.xpm");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/knight_up_walk_right.xpm");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/knight_left_walk_left.xpm");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/knight_left_walk_right.xpm");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/knight_right_walk_left.xpm");
	(*gamec)->image_files = g_list_append((*gamec)->image_files,"./images/knight_right_walk_right.xpm");

}

void init_sprites(GameControl** gamec) 
{

	init_image_files(gamec);
	g_list_foreach((*gamec)->image_files,(GFunc)load,(gamec));

}

void load(gpointer data, GameControl** gamec) {

	if(data != NULL) {

		Sprite* sprite = new_sprite();

		sprite->image = gdk_imlib_load_image(data);
		gdk_imlib_render(sprite->image,sprite->image->rgb_width,sprite->image->rgb_height);
		sprite->pixmap = gdk_imlib_copy_image(sprite->image);
		sprite->mask = gdk_imlib_copy_mask(sprite->image);

		(*gamec)->sprites = g_list_append((*gamec)->sprites,sprite);

	}

}

gboolean is_chopped_item(GameControl** gamec,Coords* tmp) {

	if(((MAP(tmp->x,tmp->y)->ios->x + MAP(tmp->x,tmp->y)->ios->width >= AREA_OX) &&
	    (MAP(tmp->x,tmp->y)->ios->x + MAP(tmp->x,tmp->y)->ios->width <= AREA_OX+XSPACES)) ||
	   ((MAP(tmp->x,tmp->y)->ios->y + MAP(tmp->x,tmp->y)->ios->height >= AREA_OY) &&
	    (MAP(tmp->x,tmp->y)->ios->y + MAP(tmp->x,tmp->y)->ios->height <= AREA_OY+YSPACES))) {
	
		return TRUE;

	}
	
	return FALSE;

}

gboolean is_chopped_monster(GameControl** gamec,Coords* tmp) {

	if(((MAP(tmp->x,tmp->y)->mos->x + MAP(tmp->x,tmp->y)->mos->width >= AREA_OX) &&
	    (MAP(tmp->x,tmp->y)->mos->x + MAP(tmp->x,tmp->y)->mos->width <= AREA_OX+XSPACES)) ||
	   ((MAP(tmp->x,tmp->y)->mos->y + MAP(tmp->x,tmp->y)->mos->height >= AREA_OY) &&
	    (MAP(tmp->x,tmp->y)->mos->y + MAP(tmp->x,tmp->y)->mos->height <= AREA_OY+YSPACES))) {
	
		return TRUE;

	}

	return FALSE;

}

gboolean is_outside_area(GameControl** gamec,Coords* tmp) {

	if(tmp != NULL) {

		if(
		   ((tmp->y > AREA_OY+((MAP_DRAWING_AREA->allocation.height)/TILE_SIZE)) && 
		    (tmp->y < AREA_OY)) ||
		   ((tmp->x > AREA_OX+((MAP_DRAWING_AREA->allocation.x)/TILE_SIZE)) &&
		    (tmp->x < AREA_OX))) {

			return TRUE;

		}

	}

	return FALSE;

}

gboolean someone_on_item(GameControl** gamec,Coords* tmp) {

	gint i,j;

	if(tmp != NULL) {

		if(MAP(tmp->x,tmp->y)->ios != NULL) {

			for(j=0;j<MAP(tmp->x,tmp->y)->ios->height;j++)
			for(i=0;i<MAP(tmp->x,tmp->y)->ios->width;i++) {

				if(MAP((MAP(tmp->x,tmp->y)->ios->x)+i,(MAP(tmp->x,tmp->y)->ios->y)+j)->mos != NULL)
					return TRUE;

			}

		}

	}

	return FALSE;

}

/* the most important drawing function,
   is's terribly complicated, I know, but I wasn't able to do it in a readable way,
   yet... sorry about that. */
void make_area(GameControl** gamec) {

	gint n;
	Coords* tmp;
	gboolean remove = TRUE;

	if(MAP_AREA == NULL) {

		MAP_AREA = gdk_pixmap_new(MAP_DRAWING_AREA->window,MAP_DRAWING_AREA->allocation.width,MAP_DRAWING_AREA->allocation.height,-1);

	}
	if(MAP_GC == NULL) {

		MAP_GC = gdk_gc_new(MAP_DRAWING_AREA->window);

	}
	
	while(MAP_UPDATE != NULL) {

		tmp = (Coords*) g_list_last(MAP_UPDATE)->data;

		/* check if there's a big thing outside the area that's partly visible */
		if(is_outside_area(gamec,tmp)) {

			if(MAP(tmp->x,tmp->y)->ios) {

				if(is_chopped_item(gamec,tmp)) {
					
					remove = FALSE;

				}

			} else if(MAP(tmp->x,tmp->y)->mos != NULL) {

				if(is_chopped_monster(gamec,tmp)) {

					remove = FALSE;

				}

			}

			if(remove == TRUE) {

				g_list_remove(MAP_UPDATE,tmp);
		
			}

		} else {

			gdk_gc_set_clip_mask(MAP_GC,NULL);
			gdk_gc_set_clip_origin(MAP_GC,(((tmp->x)-AREA_OX)*TILE_SIZE),(((tmp->y)-AREA_OY)*TILE_SIZE));
			
			n = MAP(tmp->x,tmp->y)->sprite_cur;
			gdk_draw_pixmap(MAP_DRAWING_AREA->window,MAP_GC,
			                PIXMAP(lookup_sprite_nr(MAP(tmp->x,tmp->y)->sprites,n)),
			                0,0,(((tmp->x)-AREA_OX)*TILE_SIZE),(((tmp->y)-AREA_OY)*TILE_SIZE),TILE_SIZE,TILE_SIZE);

			if(((MAP(tmp->x,tmp->y)->ios != NULL) && (MAP(tmp->x,tmp->y)->mos != NULL)) && 
			   ((MAP(tmp->x,tmp->y)->ios->x != tmp->x) || (MAP(tmp->x,tmp->y)->ios->y != tmp->y))) {

				/* there's a monster standing on a big item. */

				gdk_gc_set_clip_origin(MAP_GC,(((MAP(tmp->x,tmp->y)->ios->x)-AREA_OX)*TILE_SIZE),
				                              (((MAP(tmp->x,tmp->y)->ios->y)-AREA_OY)*TILE_SIZE));

				n = MAP(tmp->x,tmp->y)->ios->state;
				gdk_gc_set_clip_mask(MAP_GC,MASK(lookup_sprite_nr(MAP(tmp->x,tmp->y)->ios->sprites,n)));
				gdk_draw_pixmap(MAP_DRAWING_AREA->window,MAP_GC,
				                PIXMAP(lookup_sprite_nr(MAP(tmp->x,tmp->y)->ios->sprites,n)),
						0,0,
				                (((MAP(tmp->x,tmp->y)->ios->x)-AREA_OX)*TILE_SIZE),
				                (((MAP(tmp->x,tmp->y)->ios->y)-AREA_OY)*TILE_SIZE),
				                ((MAP(tmp->x,tmp->y)->ios->width)*TILE_SIZE),
				                ((MAP(tmp->x,tmp->y)->ios->height)*TILE_SIZE));

				gdk_gc_set_clip_origin(MAP_GC,(((MAP(tmp->x,tmp->y)->mos->x)-AREA_OX)*TILE_SIZE),
				                              (((MAP(tmp->x,tmp->y)->mos->y)-AREA_OY)*TILE_SIZE));

				n = MAP(tmp->x,tmp->y)->mos->state;
				gdk_gc_set_clip_mask(MAP_GC,MASK(lookup_sprite_nr(MAP(tmp->x,tmp->y)->mos->sprites,n)));
				gdk_draw_pixmap(MAP_DRAWING_AREA->window,MAP_GC,
				                PIXMAP(lookup_sprite_nr(MAP(tmp->x,tmp->y)->mos->sprites,n)),
				                0,0,
				                (((MAP(tmp->x,tmp->y)->mos->x)-AREA_OX)*TILE_SIZE),
				                (((MAP(tmp->x,tmp->y)->mos->y)-AREA_OY)*TILE_SIZE),
				                ((MAP(tmp->x,tmp->y)->mos->width)*TILE_SIZE),
				                ((MAP(tmp->x,tmp->y)->mos->height)*TILE_SIZE));
			
				gdk_gc_set_clip_origin(MAP_GC,(((tmp->x)-AREA_OX)*TILE_SIZE),(((tmp->y)-AREA_OY)*TILE_SIZE));

			}

			if(MAP(tmp->x,tmp->y)->ios != NULL) {

				/* there's a big item outside the area that sticks in */
				if((MAP(tmp->x,tmp->y)->ios->x < AREA_OX) ||
				   (MAP(tmp->x,tmp->y)->ios->y < AREA_OY)) {

					n = MAP(tmp->x,tmp->y)->ios->state;
					gdk_gc_set_clip_mask(MAP_GC,MASK(lookup_sprite_nr(MAP(tmp->x,tmp->y)->ios->sprites,n)));
					gdk_gc_set_clip_origin(MAP_GC,
					                       (((MAP(tmp->x,tmp->y)->ios->x)-AREA_OX)*TILE_SIZE),
					                       (((MAP(tmp->x,tmp->y)->ios->y)-AREA_OY)*TILE_SIZE));
					
					gdk_draw_pixmap(MAP_DRAWING_AREA->window,MAP_GC,
		  			                PIXMAP(lookup_sprite_nr(MAP(tmp->x,tmp->y)->ios->sprites,n)),
					                0,0,
					                (((MAP(tmp->x,tmp->y)->ios->x)-AREA_OX)*TILE_SIZE),
					                (((MAP(tmp->x,tmp->y)->ios->y)-AREA_OY)*TILE_SIZE),
					                ((MAP(tmp->x,tmp->y)->ios->width)*TILE_SIZE),
					                ((MAP(tmp->x,tmp->y)->ios->height)*TILE_SIZE));

				}

				/* there's an item in the area to draw */
				if(MAP(tmp->x,tmp->y)->ios->x == tmp->x &&
				   MAP(tmp->x,tmp->y)->ios->y == tmp->y) {

					n = MAP(tmp->x,tmp->y)->ios->state;
					gdk_gc_set_clip_mask(MAP_GC,MASK(lookup_sprite_nr(MAP(tmp->x,tmp->y)->ios->sprites,n)));
					gdk_draw_pixmap(MAP_DRAWING_AREA->window,MAP_GC,
					                PIXMAP(lookup_sprite_nr(MAP(tmp->x,tmp->y)->ios->sprites,n)),
							0,0,(((tmp->x)-AREA_OX)*TILE_SIZE),
					                (((tmp->y)-AREA_OY)*TILE_SIZE),((MAP(tmp->x,tmp->y)->ios->width)*TILE_SIZE),
					                ((MAP(tmp->x,tmp->y)->ios->height)*TILE_SIZE));
	
				} else {

					if(someone_on_item(gamec,tmp) == FALSE) {

						add_update(gamec,MAP(tmp->x,tmp->y)->ios->x,MAP(tmp->x,tmp->y)->ios->y);			
	
					}

				}

			}

			if(MAP(tmp->x,tmp->y)->mos != NULL) {

				/* there's a big monster outside the area that sticks in */
				if((MAP(tmp->x,tmp->y)->mos->x < AREA_OX) ||
				   (MAP(tmp->x,tmp->y)->mos->y < AREA_OY)) {
					
					n = MAP(tmp->x,tmp->y)->mos->state;
					gdk_gc_set_clip_mask(MAP_GC,MASK(lookup_sprite_nr(MAP(tmp->x,tmp->y)->mos->sprites,n)));
					gdk_gc_set_clip_origin(MAP_GC,
					                       (((MAP(tmp->x,tmp->y)->mos->x)-AREA_OX)*TILE_SIZE),
					                       (((MAP(tmp->x,tmp->y)->mos->y)-AREA_OY)*TILE_SIZE));

					gdk_draw_pixmap(MAP_DRAWING_AREA->window,MAP_GC,
					                PIXMAP(lookup_sprite_nr(MAP(tmp->x,tmp->y)->mos->sprites,n)),
					                0,0,
					                (((MAP(tmp->x,tmp->y)->mos->x)-AREA_OX)*TILE_SIZE),
					                (((MAP(tmp->x,tmp->y)->mos->y)-AREA_OY)*TILE_SIZE),
					                ((MAP(tmp->x,tmp->y)->mos->width)*TILE_SIZE),
					                ((MAP(tmp->x,tmp->y)->mos->height)*TILE_SIZE));

				}

				/* there's a monster in the area to draw */
				if((MAP(tmp->x,tmp->y)->mos->x == tmp->x) &&
				   (MAP(tmp->x,tmp->y)->mos->y == tmp->y)) {

					n = MAP(tmp->x,tmp->y)->mos->state;
					gdk_gc_set_clip_mask(MAP_GC,MASK(lookup_sprite_nr(MAP(tmp->x,tmp->y)->mos->sprites,n)));
					gdk_draw_pixmap(MAP_DRAWING_AREA->window,MAP_GC,
					                PIXMAP(lookup_sprite_nr(MAP(tmp->x,tmp->y)->mos->sprites,n)),
					                0,0,
					                (((tmp->x)-AREA_OX)*TILE_SIZE),
					                (((tmp->y)-AREA_OY)*TILE_SIZE),
					                ((MAP(tmp->x,tmp->y)->mos->width)*TILE_SIZE),
					                ((MAP(tmp->x,tmp->y)->mos->height)*TILE_SIZE));
				
				} else {

					add_update(gamec,MAP(tmp->x,tmp->y)->mos->x,MAP(tmp->x,tmp->y)->mos->y);

				}

			}

			MAP_UPDATE = g_list_remove(MAP_UPDATE,tmp);

		}

	}

}

void animate_space(GameControl** gamec,gint x,gint y) {

	gint rn,tmp;

	if(MAP(x,y)->animates) {

	}

	if((MAP(x,y)->ios != NULL) && (MAP(x,y)->ios->animates)) {
			
		switch(MAP(x,y)->ios->sub_sort) {

			case CAMP_FIRE:
				rn = rand()%4;

				if(MAP(x,y)->ios->state == ON_FIRE_1 ||
				   MAP(x,y)->ios->state == ON_FIRE_2 ||
				   MAP(x,y)->ios->state == ON_FIRE_3 ||
				   MAP(x,y)->ios->state == ON_FIRE_4) {

						if((rn + ON_FIRE_1) == (MAP(x,y)->ios->state)) {
						
						if((MAP(x,y)->ios->state) == (ON_FIRE_4)) {
						
							tmp = (ON_FIRE_1);
							
						} else { 
						
							tmp = (rn + (ON_FIRE_1)) + 1;
						}
					
					} else {
				
						tmp = (rn + (ON_FIRE_1));
				
					}

					MAP(x,y)->ios->state = tmp;
					add_update(gamec,x,y);

				} else {

				} break;

			default: 
				break;
		
		}
	}

	if(MAP(x,y)->mos != NULL) {

	}

}

void update_area_spaces(GameControl** gamec) {
	
	gint x,y;

	for(y=AREA_OY;y<=(AREA_OY+(MAP_DRAWING_AREA->allocation.height/TILE_SIZE));y++)
	for(x=AREA_OX;x<=(AREA_OX+(MAP_DRAWING_AREA->allocation.width/TILE_SIZE));x++) {

		animate_space(gamec,x,y);

	}

}

void repaint_drawing_area(GameControl** gamec) {

	GdkRectangle update_rect;
	
	make_area(gamec);

	update_rect.x = 0;
	update_rect.y = 0;
	update_rect.width = MAP_DRAWING_AREA->allocation.width;
	update_rect.height = MAP_DRAWING_AREA->allocation.height;
	
	gtk_widget_draw(MAP_DRAWING_AREA,&update_rect);

}

GList* add_sprite(GList* sprite_list,gint32 key,gint16 nr) {

	SpriteNr* new = new_sprite_nr();

	sprite_list = g_list_append(sprite_list,new);

	((SpriteNr*)g_list_last(sprite_list)->data)->key = key;
	((SpriteNr*)g_list_last(sprite_list)->data)->nr = nr;

	return sprite_list;

}

gint16 lookup_sprite_nr(GList* sprite_list,gint32 key) {

	GList* walker = sprite_list;

	while(walker != NULL) {

		if(((SpriteNr*)walker->data) != NULL)
		if(((SpriteNr*)walker->data)->key == key) {

			return ((SpriteNr*)walker->data)->nr;

		} else {

			walker = walker->next;

		}

	}

	return -1;

}
